<?php
declare(strict_types=1);

namespace FiloBlu\Refilo\Model\Observer;

use Exception;
use Magento\Catalog\Api\Data\CategoryInterface;
use Magento\Catalog\Model\Category;
use Magento\Framework\Event\Observer;
use Magento\Framework\Event\ObserverInterface;

/**
 *
 */
class CategorySaveAfterObserver implements ObserverInterface
{

    /**
     * @param Observer $observer
     * @throws Exception
     */
    public function execute(Observer $observer)
    {
        /** @var CategoryInterface|Category $category */
        $category = $observer->getData('category');
        $value = (int)$category->getData('refilo_exclude_from_search');

        foreach($category->getChildrenCategories() as $child) {
            // TODO: find a more efficient way to do this (avoid recursion)
            $child->setData('refilo_exclude_from_search', $value)->save();
        }
    }

}
